:- dynamic
      clause/1.
:- multifile
      clause/1.
:- dynamic
      clause_a/1.
:- multifile
      clause_a/1.
:- dynamic
      clause_c/1.
:- multifile
      clause_c/1.
:-[input].
%%%%% %%%%%%%% %%%%%%%%  %%%%%%%%
%       EXTERNAL CALL
%%%%% %%%%%%%% %%%%%%%%  %%%%%%%%
ground_program :-
            	 open('gp.pl',write,Out),
               	 %ground_clauses_a(Out),
               	 ground_clauses(Out),
            	 close(Out),halt.
%%%%% %%%%%%%% %%%%%%%%  %%%%%%%%
%       PROLOG QUERIES
%%%%% %%%%%%%% %%%%%%%%  %%%%%%%%


%clause(p:-[n(a)]).
%clause(a:-[f]).
%converts clauses from the format clause(':-'(h,b1,b2...,bn)) into clause(h:-[b1,b2,...,bn])
%r(X,X):-n(q(X,Y)),p(Y,X)
convert_clauses:-
clause_b(C1),
C1=..[':-'|LIST],
[H|B]=LIST,
assert(clause(H :- B)),
fail.


lista(L):-clause_g(C),C=..L.
clausesall(List) :-clause(C),term_variables(C, List).

ground_clauses_a(Out) :-
	 all_cons(Atoms),
	 clause_a(H,Body),
	 member(Bo,Body),
	 Bo=..[_|B],
	 H=..Hlist,
	 getvars(Hlist,Vs),
	 B=..Blist, % multiple literals
	 getvars(Blist,Vsb),
	 assert(varsbody(Blist,Vsb)),
	 append(Vs,Vsb,Vars),
     %getvars(HBList,Vsb),
     Vars\=[],
     instantiate_vs(Vars, Atoms),
     Ht=H,
	 assert(clause(Ht :- [Body])), %  Bt  B2
	 write(Out,clause(Ht :- Body)),
	 write(Out,'.\n'),
	   fail
     	; true
	 .

% We use clause_a for those clauses which are not ground.
ground_clauses(Out) :-
	all_cons(Atoms),
	%write(Out,theatoms(Atoms) ),
    %write(Out,'.\n'),
	assert(constants(Atoms)),
	( clause_a(C),
	  term_variables(C, Vs),
	 % Vs\=[],
	  instantiate_vs(Vs, Atoms),
	  assert( clause(C) ),
	  write(Out,clause(C) ),
      write(Out,'.\n'),
      fail
	; true
	) .



terms_list([H|B], [B,C]):-terms_list(H,C),!.
terms_list(L, [L]):-!.

%terms_list(E, [_|L]) :- terms_list(E, L).




instantiate_vs([], _).
instantiate_vs([X|Xs], Atoms) :-
	member(X, Atoms),
	%X\=[],
	instantiate_vs(Xs, Atoms).
%instantiate_vs([X], Atoms) :-member(X, Atoms).


% all_cons(All) specifies the list of all constants in the
% initial program.

all_cons(All) :-
%	current_predicate(clause/1),
	%setof(List, get_constants2([List]), All) -> true;
	setof(List, get_constants2([List]), All) -> true;
	All = [aux_c].



get_constants2(List) :-
	clause_c(H :- _),
	H =..[_|Atoms],
	%assert(atoms(Atoms)),
	member(A, Atoms),
	A\=[],
	setof(A, atomic(A), List),
	assert(headatom(A)).

%body
get_constants2(List) :-
	clause_c(_ :- Body),
	%Body =..Bodys,
	member(B,Body),
	B=..[_|Atoms],
	member(A, Atoms),
	%A\=[],
	setof(A, atomic(A), List),
	assert(bodyatom(A)).



get_constants(List) :-
	clause_c(H :- _),
	H =..[H1|Atoms],
	H1\='.', %avoid taking predicates as constants
	member(A, Atoms),
	setof(A, atomic(A), List),
	assert(headatom(A)).

%many literals in the body
get_constants(List) :-
	clause_c(C),
	C=..[_|B],
	assert(abody(B)),
	member(Bmem,B),
	%assert(amember(Bmem)),
	Bmem =..[H|Atoms],
    H\='.', %avoid taking t,f as constants
    member(A, Atoms),
    %assert(aatom(H,A)),
    setof(A, atomic(A), List).

%only one literal in the body
get_constants(List) :-
	clause_c(_ :- Body),
	Body =..[H|Atoms],
	H\='.', %avoid taking t,f as constants
	member(A, Atoms),
	setof(A, atomic(A), List).



	%%%%%   NEW   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%KF! terms with more than one FREE variable, dont work
getvars([H],[H]):-var(H),!.
getvars([H],[]):-!.
%% if head is a Term
getvars([H|T],[H|L]):-var(H),getvars(T,L),!.

getvars([H|T],L):-H=..[H2|B2],member(Neg,B2),Neg=..[Nh|Nb],getvars(Nb,L1),getvars(T,L2),append(L1,L2,L),!.
%assert(negated(B2,Neg,Nh,Nb)).
%,fail.

getvars([H|T],L):-H=..[H2|B2],getvars(B2,L1),getvars(T,L2),append(L1,L2,L),!. % MOVED if head is a Term


%,getvars([Neg|T],L). % ,!. %  if head is a negated Term



getvars([H|T],L):-getvars(T,L),!.

%getvars([H],Bd):-H=[T1|T2],T1=..[List|Bd],!.
% GET VARS FROM Bd!!
%gevars([n(H)],L):-getvars(H,L).
%getvars([H|Rest],L):-H=..[H1|H2],H2=..[_,T],getvars(T,L1),getvars(Rest,L2),append(L1,L2,L). %to handle negation
%getvars([H|T],L):-H=..[H2|B2],B2=..[H3|B3],getvars(B3,L1),getvars(T,L2),append(L1,L2,L),!. % if head is a negated Term